# Autogenerated wrapper script for tblis_jll for x86_64-linux-musl-cxx03
export tblis, tci

using Hwloc_jll
using CompilerSupportLibraries_jll
## Global variables
PATH = ""
LIBPATH = ""
LIBPATH_env = "LD_LIBRARY_PATH"
LIBPATH_default = ""

# Relative path to `tblis`
const tblis_splitpath = ["lib", "libtblis.so.0"]

# This will be filled out by __init__() for all products, as it must be done at runtime
tblis_path = ""

# tblis-specific global declaration
# This will be filled out by __init__()
tblis_handle = C_NULL

# This must be `const` so that we can use it with `ccall()`
const tblis = "libtblis.so.0"


# Relative path to `tci`
const tci_splitpath = ["lib", "libtci.so.0"]

# This will be filled out by __init__() for all products, as it must be done at runtime
tci_path = ""

# tci-specific global declaration
# This will be filled out by __init__()
tci_handle = C_NULL

# This must be `const` so that we can use it with `ccall()`
const tci = "libtci.so.0"


"""
Open all libraries
"""
function __init__()
    global artifact_dir = abspath(artifact"tblis")

    # Initialize PATH and LIBPATH environment variable listings
    global PATH_list, LIBPATH_list
    # We first need to add to LIBPATH_list the libraries provided by Julia
    append!(LIBPATH_list, [joinpath(Sys.BINDIR, Base.LIBDIR, "julia"), joinpath(Sys.BINDIR, Base.LIBDIR)])
    # From the list of our dependencies, generate a tuple of all the PATH and LIBPATH lists,
    # then append them to our own.
    foreach(p -> append!(PATH_list, p), (Hwloc_jll.PATH_list, CompilerSupportLibraries_jll.PATH_list,))
    foreach(p -> append!(LIBPATH_list, p), (Hwloc_jll.LIBPATH_list, CompilerSupportLibraries_jll.LIBPATH_list,))

    global tblis_path = normpath(joinpath(artifact_dir, tblis_splitpath...))

    # Manually `dlopen()` this right now so that future invocations
    # of `ccall` with its `SONAME` will find this path immediately.
    global tblis_handle = dlopen(tblis_path)
    push!(LIBPATH_list, dirname(tblis_path))

    global tci_path = normpath(joinpath(artifact_dir, tci_splitpath...))

    # Manually `dlopen()` this right now so that future invocations
    # of `ccall` with its `SONAME` will find this path immediately.
    global tci_handle = dlopen(tci_path)
    push!(LIBPATH_list, dirname(tci_path))

    # Filter out duplicate and empty entries in our PATH and LIBPATH entries
    filter!(!isempty, unique!(PATH_list))
    filter!(!isempty, unique!(LIBPATH_list))
    global PATH = join(PATH_list, ':')
    global LIBPATH = join(LIBPATH_list, ':')

    # Add each element of LIBPATH to our DL_LOAD_PATH (necessary on platforms
    # that don't honor our "already opened" trick)
    #for lp in LIBPATH_list
    #    push!(DL_LOAD_PATH, lp)
    #end
end  # __init__()

